unit U_OldOrderNOCKList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData,
  cxDataStorage, cxEdit, DB, cxDBData, cxGridCustomTableView,
  cxGridTableView, cxGridBandedTableView, cxGridDBBandedTableView,
  cxGridLevel, cxClasses, cxControls, cxGridCustomView, cxGridDBTableView,
  cxGrid, StdCtrls, ComCtrls, ExtCtrls, ToolWin, cxGridCustomPopupMenu,
  cxGridPopupMenu, ADODB, DBClient, cxDropDownEdit, cxCheckBox, RM_Common,
  RM_Class, RM_e_Xls, RM_Dataset, RM_System, RM_GridReport, Menus,
  cxCalendar, cxPC;

type
  TfrmOldOrderNOCKList = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    cxGridPopupMenu1: TcxGridPopupMenu;
    Label1: TLabel;
    Label2: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    CDS_Main: TClientDataSet;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column1: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v2Column3: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v2Column5: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    RM1: TRMGridReport;
    RMDBMain: TRMDBDataSet;
    RMXLSExport1: TRMXLSExport;
    RMDBHZ: TRMDBDataSet;
    CDS_HZ: TClientDataSet;
    CDS_PRT: TClientDataSet;
    TBRKCX: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    v1Column5: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v1Column15: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    SPName: TEdit;
    FactoryName: TEdit;
    SXID: TEdit;
    BatchNO: TEdit;
    v1Column8: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    Label6: TLabel;
    SPSpec: TEdit;
    Label7: TLabel;
    SPMF: TEdit;
    Label9: TLabel;
    SPKZ: TEdit;
    Label11: TLabel;
    SPType: TComboBox;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    cxTabControl1: TcxTabControl;
    v1Column12: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    v1Column16: TcxGridDBColumn;
    v1Column11: TcxGridDBColumn;
    v1Column4: TcxGridDBColumn;
    Label10: TLabel;
    KuWei: TEdit;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBRKCXClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure SXIDKeyPress(Sender: TObject; var Key: Char);
    procedure SXIDChange(Sender: TObject);
    procedure BatchNOChange(Sender: TObject);
    procedure FactoryNameChange(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
  private
    procedure InitGrid();
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOldOrderNOCKList: TfrmOldOrderNOCKList;

implementation
uses
  U_DataLink,U_RTFun,U_OldOrderNoInPut;

{$R *.dfm}

procedure TfrmOldOrderNOCKList.FormDestroy(Sender: TObject);
begin
  frmOldOrderNOCKList:=nil;
end;

procedure TfrmOldOrderNOCKList.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmOldOrderNOCKList.FormCreate(Sender: TObject);
begin
  //cxGrid1.Align:=alClient;
  EndDate.DateTime:=SGetServerDate10(ADOQueryTemp);
  BegDate.DateTime:=EndDate.DateTime;
end;

procedure TfrmOldOrderNOCKList.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      sql.Clear;
      sql.Add(' select A.* ');
      sql.Add(' from CK_SXPB_CR A');
      sql.add('where A.CRTime>=:begdate and A.CRTime<:enddate and isnull(CKName,'''')=''老单号'' ');
      SQL.Add(' and CRFlag=''入库''  ');
      if cxTabControl1.TabIndex=0 then
      begin
        sql.Add(' and isnull(SChker,'''')='''' ');
      end else
      if cxTabControl1.TabIndex=1 then
      begin
        sql.Add(' and isnull(SChker,'''')<>'''' ');
      end;
      Parameters.ParamByName('begdate').Value:=Trim(FormatDateTime('yyyy-MM-dd',BegDate.DateTime));
      Parameters.ParamByName('enddate').Value:=Trim(FormatDateTime('yyyy-MM-dd',enddate.DateTime+1));
      Open;
      //ShowMessage(SQL.Text);
    end;
    SCreateCDS20(ADOQueryMain,CDS_Main);
    SInitCDSData20(ADOQueryMain,CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmOldOrderNOCKList.TBRafreshClick(Sender: TObject);
begin
  BegDate.SetFocus;
  InitGrid();
end;

procedure TfrmOldOrderNOCKList.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  end;
end;

procedure TfrmOldOrderNOCKList.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('老单号入库列表',Tv1,'老单号仓库');
  Close;
end;

procedure TfrmOldOrderNOCKList.FormShow(Sender: TObject);
begin
  ReadCxGrid('老单号入库列表',Tv1,'老单号仓库');
  //InitGrid();
end;

procedure TfrmOldOrderNOCKList.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then exit;
  TcxGridToExcel('老单号入库列表',cxGrid2);
end;

procedure TfrmOldOrderNOCKList.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
    SCreateCDS20(ADOQueryMain,CDS_Main);
    SInitCDSData20(ADOQueryMain,CDS_Main);
  end;
end;

procedure TfrmOldOrderNOCKList.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_Main,True);
end;

procedure TfrmOldOrderNOCKList.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main,False);
end;

procedure TfrmOldOrderNOCKList.TBRKCXClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then Exit;
  if cxTabControl1.TabIndex<>0 then Exit;
  if Trim(CDS_Main.fieldbyname('SPID').AsString)<>'' then
  begin
    if Application.MessageBox('确定要删除数据吗？','提示',32+4)<>IDYES then Exit;
    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' delete CK_SXPB_CR where SPID='''+Trim(CDS_Main.fieldbyname('SPID').AsString)+'''');
        sql.Add(' Update CK_SXPB_KC Set KCKGQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_SXPB_CR A where A.CRID=CK_SXPB_KC.CRID)');
        sql.Add(',KCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.CRID=CK_SXPB_KC.CRID)');
        sql.Add(' where CRID='+Trim(CDS_Main.fieldbyname('CRID').AsString));
        ExecSQL;
      end;
      with ADOQueryTemp do
      begin
        Close;
        sql.Clear;
        sql.Add('select KCKGQty=isnull(KCQty,0) from CK_SXPB_KC where CRID='+Trim(CDS_Main.fieldbyname('CRID').AsString));
        Open;
      end;
      if ADOQueryTemp.IsEmpty=False then
      begin
        if ADOQueryTemp.FieldByName('KCQty').Value<0 then
        begin
          ADOQueryCmd.Connection.RollbackTrans;
          Application.MessageBox('入库数小于出库数不能删除!','提示',0);
          Exit;
        end;
      end;

      ADOQueryCmd.Connection.CommitTrans;
      CDS_Main.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('删除异常!','提示',0);
    end;

  end else
  begin
    CDS_Main.Delete;
  end;
end;

procedure TfrmOldOrderNOCKList.ToolButton1Click(Sender: TObject);
begin
  try
    frmOldOrderNoInPut:=TfrmOldOrderNoInPut.Create(Application);
    with frmOldOrderNoInPut do
    begin
      FBCId:='';
      if ShowModal=1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmOldOrderNoInPut.Free;
  end;
end;

procedure TfrmOldOrderNOCKList.ToolButton2Click(Sender: TObject);
begin
  if cxTabControl1.TabIndex<>0 then Exit;
  try
    frmOldOrderNoInPut:=TfrmOldOrderNoInPut.Create(Application);
    with frmOldOrderNoInPut do
    begin
      FBCId:=Trim(CDS_Main.fieldbyname('SPID').AsString);
      TBDel.Visible:=False;
      TBAdd.Visible:=False;
      if ShowModal=1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmOldOrderNoInPut.Free;
  end;
end;

procedure TfrmOldOrderNOCKList.SXIDKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then
  begin
    if Length(Trim(SXID.Text))<4 then Exit;
    try
      ADOQueryMain.DisableControls;
      with ADOQueryMain do
      begin
        Filtered:=False;
        Close;
        sql.Clear;
        sql.Add(' select A.* ');
        //sql.Add(' ,CGConNo=(select ConNo from Contract_Main CM where CM.MainId=A.CGConMainId )');
        sql.Add(' from CK_SXPB_CR A');
        sql.add(' where SXID like :SXID');
        if cxTabControl1.TabIndex=0 then
        begin
          sql.Add(' and isnull(SChker,'''')='''' ');
        end else
        if cxTabControl1.TabIndex=1 then
        begin
          sql.Add(' and isnull(SChker,'''')<>'''' ');
        end;
        Parameters.ParamByName('SXID').Value:='%'+Trim(SXID.Text)+'%';
        Open;
        //ShowMessage(SQL.Text);
      end;
      SCreateCDS20(ADOQueryMain,CDS_Main);
      SInitCDSData20(ADOQueryMain,CDS_Main);
    finally
      ADOQueryMain.EnableControls;
    end;
  end;
end;

procedure TfrmOldOrderNOCKList.SXIDChange(Sender: TObject);
begin
  if Length(Trim(SXID.Text))<4 then
  begin
    if Trim(SXID.Text)<>'' then Exit;
  end;
  TBFind.Click;
end;

procedure TfrmOldOrderNOCKList.BatchNOChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmOldOrderNOCKList.FactoryNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmOldOrderNOCKList.ToolButton3Click(Sender: TObject);
begin
  if cxTabControl1.TabIndex<>0 then Exit;
  if CDS_Main.IsEmpty then Exit;
  if Application.MessageBox('确定要执行此操作吗？','提示',32+4)<>IDYES then exit;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('Update CK_SXPB_CR Set SChker='''+Trim(DName)+'''');
    SQL.Add(',SChkTime=getdate() ');
    sql.Add(' where SPID='''+Trim(CDS_Main.fieldbyname('SPID').AsString)+'''');
    ExecSQL;
  end;
  CDS_Main.Delete;
end;

procedure TfrmOldOrderNOCKList.ToolButton4Click(Sender: TObject);
begin
  if cxTabControl1.TabIndex<>1 then Exit;
  if CDS_Main.IsEmpty then Exit;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    SQL.Add('select * from CK_SXPB_CR ');
    sql.Add(' where SPID='''+Trim(CDS_Main.fieldbyname('SPID').AsString)+'''');
    sql.Add(' and isnull(ChkStatus,'''')<>'''' ');
    Open;
  end;
  if ADOQueryTemp.IsEmpty=False then
  begin
    Application.MessageBox('已审核通过，不能撤销!','提示',0);
    Exit;
  end;
  if Application.MessageBox('确定要执行此操作吗？','提示',32+4)<>IDYES then exit;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('Update CK_SXPB_CR Set SChker=NUll');
    SQL.Add(',SChkTime=Null ');
    sql.Add(' where SPID='''+Trim(CDS_Main.fieldbyname('SPID').AsString)+'''');
    ExecSQL;
  end;
  CDS_Main.Delete;
end;

procedure TfrmOldOrderNOCKList.cxTabControl1Change(Sender: TObject);
begin
  InitGrid();
end;

end.
